local function AddItem(ItemEntryBox, ScrollingTable, PrimarySpecRadioButton, SecondarySpecRadioButton, ViewPrimarySpec, ViewSecondarySpec, MF, priorityfield, statusbarfont, NoteEntryBox)
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(ItemEntryBox:GetText());
	if itemEquipLoc == nil then
		--item isn't equipable, figure out something to do with it
	else
		local localizedClass, englishClass = UnitClass("player");
		if englishClass == "DEATHKNIGHT" then
			if itemSubType ~= "Cloth" or "Leather" or "Mail" or "Plate" or "Relic" or "One-Handed Maces" or "Two-Handed Maces" or "Polearms" or "One-Handed Swords" or "Two-Handed Swords" or "One-Handed Axes" or "Two-Handed Axes" then
				--The player CANNOT equip the item.
			else
				--The player CAN equip the item.
			end
		elseif englishClass == "DRUID" then
			if itemSubType ~= "Cloth" or "Leather" or "Relic" or "Daggers" or "Fist Weapons" or "One-Handed Maces" or "Polearms" or "Staves" or "Two-Handed Maces" or "Miscellaneous" then
				--The player CANNOT equip the item.
			else
				--The player CAN equip the item.
			end
		elseif englishClass == "HUNTER" then
			if itemSubType ~= "Cloth" or "Leather" or "Mail" or "Guns" or "Bows" or "Crossbows" or "Thrown" or "Fist Weapons" or "One-Handed Axes" or "One-Handed Swords" or "Polearms" or "Staves" or "Two-Handed Axes" or "Two-Handed Swords" then
				--The player CANNOT equip the item.
			else
				--The player CAN equip the item.
			end
		elseif englishClass == "MAGE" then
			if itemSubType ~= "Cloth" or "Staves" or "Wands" or "Daggers" or "One-Handed Swords" or "Miscellaneous" then
				--The player CANNOT equip the item.
			else
				--The player CAN equip the item.
			end
		elseif englishClass == "PALADIN" then
			if itemSubType ~= "Cloth" or "Leather" or "Mail" or "Plate" or "Shields" or "Relic" or "One-Handed Maces" or "Two-Handed Maces" or "Polearms" or "One-Handed Swords" or "Two-Handed Swords" or "One-Handed Axes" or "Two-Handed Axes" then
				--The player CANNOT equip the item.
			else
				--The player CAN equip the item.
			end
		elseif englishClass == "PRIEST" then
			if itemSubType ~= "Cloth" or "Staves" or "Wands" or "Daggers" or "One-Handed Maces" or "Miscellaneous" then
				--The player CANNOT equip the item.
			else
				--The player CAN equip the item.
			end
		elseif englishClass == "ROGUE" then
			if itemSubType ~= "Cloth" or "Leather" or "Daggers" or "Fist Weapons" or "One-Handed Maces" or "One-Handed Axes" or "One-Handed Swords" or "Bows" or "Crossbows" or "Thrown" or "Guns" then
				--The player CANNOT equip the item.
			else
				--The player CAN equip the item.
			end
		elseif englishClass == "SHAMAN" then
			if itemSubType ~= "Cloth" or "Leather" or "Mail" or "Shields" or "Daggers" or "Fist Weapons" or "One-Handed Maces" or "One-Handed Axes" or "Relic" or "Staves" or "Two-Handed Maces" or "Two-Handed Axes" then
				--The player CANNOT equip the item.
			else
				--The player CAN equip the item.
			end
		elseif englishClass == "WARLOCK" then
			if itemSubType ~= "Cloth" or "Staves" or "Wands" or "Daggers" or "One-Handed Swords" or "Miscellaneous" then
				--The player CANNOT equip the item.
			else
				--The player CAN equip the item.
			end
		elseif englishClass == "WARRIOR" then
			if (itemSubType ~= "Cloth") and (itemSubType ~= "Leather") and (itemSubType ~= "Mail") and (itemSubType ~= "Plate") and (itemSubType ~= "Shields") and (itemSubType ~= "Bows") and (itemSubType ~= "Crossbows") and (itemSubType ~= "Fist Weapons") and (itemSubType ~= "Guns") and (itemSubType ~= "One-Handed Axes") and (itemSubType ~= "One-Handed Maces") and (itemSubType ~= "One-Handed Swords") and (itemSubType ~= "Polearms") and (itemSubType ~= "Staves") and (itemSubType ~= "Two-Handed Axes") and (itemSubType ~= "Two-Handed Maces") and (itemSubType ~= "Two-Handed Swords") and (itemSubType ~= "Miscellaneous") then
				--The player CANNOT equip the equipable item
				statusbarfont:SetTextColor(1, 0, 0);
				statusbarfont:SetText("Your character cannot equip " .. itemLink);
				ItemEntryBox:HighlightText();
			else --Player can equip the item
				local priorityfieldnum = tonumber(priorityfield:GetText());
				if priorityfieldnum ~= nil then
					priorityfieldnum = math.floor(priorityfieldnum);
				end
				if itemEquipLoc == "INVTYPE_HEAD" then --Head Item
					if priorityfieldnum == nil and priorityfield:GetText() ~= "" then
						statusbarfont:SetTextColor(1, 0, 0);
						statusbarfont:SetText("Priority field must be a number.");
						priorityfield:HighlightText();
					elseif UPGRADELIST_SELECTEDBOSS == nil then
						statusbarfont:SetTextColor(1, 0, 0);
						statusbarfont:SetText("You must select an item location.");
						ItemEntryBox:ClearFocus();
						NoteEntryBox:ClearFocus();
						priorityfield:ClearFocus();
					elseif priorityfield:GetText() == "" or priorityfieldnum > UpgradeListDBVar.char.PrimarySpecList.Head.Count then --Priority # entered was blank or bigger than the list of items
						if PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
							UpgradeListDBVar.char.PrimarySpecList.Head.Row[UpgradeListDBVar.char.PrimarySpecList.Head.Count] = { UpgradeListDBVar.char.PrimarySpecList.Head.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
							UPGRADELIST_SELECTEDINSTANCE = nil;
							UPGRADELIST_SELECTEDBOSS = nil;
							UPGRADELIST_SELECTEDDIFFICULTY = nil;
							UpgradeListDBVar.char.PrimarySpecList.Head.Count = UpgradeListDBVar.char.PrimarySpecList.Head.Count + 1;
							statusbarfont:SetTextColor(0, 1, 0);
							statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Head tab.");
							ItemEntryBox:SetText("");
							ItemEntryBox:ClearFocus();
							NoteEntryBox:SetText("");
							NoteEntryBox:ClearFocus();
							priorityfield:SetText("");
							priorityfield:ClearFocus();
							UIDropDownMenu_SetText(DropDown_Button, "Location:");
							if (PanelTemplates_GetSelectedTab(MF) == 1) and (ViewPrimarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
								LoadHeadItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
							end
						else --Adding to SecondarySpecList
							UpgradeListDBVar.char.SecondarySpecList.Head.Row[UpgradeListDBVar.char.SecondarySpecList.Head.Count] = { UpgradeListDBVar.char.SecondarySpecList.Head.Count, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() };
							UPGRADELIST_SELECTEDINSTANCE = nil;
							UPGRADELIST_SELECTEDBOSS = nil;
							UPGRADELIST_SELECTEDDIFFICULTY = nil;
							UpgradeListDBVar.char.SecondarySpecList.Head.Count = UpgradeListDBVar.char.SecondarySpecList.Head.Count + 1;
							statusbarfont:SetTextColor(0, 1, 0);
							statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Head tab.");
							ItemEntryBox:SetText("");
							ItemEntryBox:ClearFocus();
							NoteEntryBox:SetText("");
							NoteEntryBox:ClearFocus();
							priorityfield:SetText("");
							priorityfield:ClearFocus();
							UIDropDownMenu_SetText(DropDown_Button, "Location:");
							if (PanelTemplates_GetSelectedTab(MF) == 1) and (ViewSecondarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
								LoadHeadItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
							end
						end
					elseif priorityfieldnum <= UpgradeListDBVar.char.PrimarySpecList.Head.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
						if PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
							table.insert(UpgradeListDBVar.char.PrimarySpecList.Head.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
							UPGRADELIST_SELECTEDINSTANCE = nil;
							UPGRADELIST_SELECTEDBOSS = nil;
							UPGRADELIST_SELECTEDDIFFICULTY = nil;
							for i = UpgradeListDBVar.char.PrimarySpecList.Head.Count, priorityfieldnum, -1 do
								UpgradeListDBVar.char.PrimarySpecList.Head.Row[i][1] = i;
							end
							UpgradeListDBVar.char.PrimarySpecList.Head.Count = UpgradeListDBVar.char.PrimarySpecList.Head.Count + 1;
							statusbarfont:SetTextColor(0, 1, 0);
							statusbarfont:SetText("Successfully added " .. itemLink .. " to your Primary Spec's Head tab.");
							ItemEntryBox:SetText("");
							ItemEntryBox:ClearFocus();
							NoteEntryBox:SetText("");
							NoteEntryBox:ClearFocus();
							priorityfield:SetText("");
							priorityfield:ClearFocus();
							UIDropDownMenu_SetText(DropDown_Button, "Location:");
							if (PanelTemplates_GetSelectedTab(MF) == 1) and (ViewPrimarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
								LoadHeadItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
							end
						else --Adding to Secondary Spec List
							table.insert(UpgradeListDBVar.char.SecondarySpecList.Head.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UPGRADELIST_SELECTEDDIFFICULTY, UPGRADELIST_SELECTEDINSTANCE, UPGRADELIST_SELECTEDBOSS, NoteEntryBox:GetText(), ItemEntryBox:GetText() });
							UPGRADELIST_SELECTEDINSTANCE = nil;
							UPGRADELIST_SELECTEDBOSS = nil;
							UPGRADELIST_SELECTEDDIFFICULTY = nil;
							for i = UpgradeListDBVar.char.SecondarySpecList.Head.Count, priorityfieldnum, -1 do
								UpgradeListDBVar.char.SecondarySpecList.Head.Row[i][1] = i;
							end
							UpgradeListDBVar.char.SecondarySpecList.Head.Count = UpgradeListDBVar.char.SecondarySpecList.Head.Count + 1;
							statusbarfont:SetTextColor(0, 1, 0);
							statusbarfont:SetText("Successfully added " .. itemLink .. " to your Secondary Spec's Head tab.");
							ItemEntryBox:SetText("");
							ItemEntryBox:ClearFocus();
							NoteEntryBox:SetText("");
							NoteEntryBox:ClearFocus();
							priorityfield:SetText("");
							priorityfield:ClearFocus();
							UIDropDownMenu_SetText(DropDown_Button, "Location:");
							if (PanelTemplates_GetSelectedTab(MF) == 1) and (ViewSecondarySpec:GetChecked() == 1) then --If you're viewing the tab you're adding to
								LoadHeadItems(ScrollingTable, ViewSecondarySpec, ViewSecondarySpec);
							end
						end
					else
						statusbarfont:SetTextColor(1, 0, 0);
						statusbarfont:SetText(priorityfield:GetText() .. " is not a valid number for the priority number.");
						priorityfield:HighlightText();
					end
				elseif itemEquipLoc == "INVTYPE_NECK" then --Neck Item
					if PrimarySpecRadioButton:GetChecked() then
						UpgradeListDBVar.char.PrimarySpecList.Neck.Row[UpgradeListDBVar.char.PrimarySpecList.Neck.Count] = { UpgradeListDBVar.char.PrimarySpecList.Neck.Count, itemLevel, UPGRADELIST_SELECTEDDIFFICULTY, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.PrimarySpecList.Neck.Count = UpgradeListDBVar.char.PrimarySpecList.Neck.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 2) and (ViewPrimarySpec:GetChecked() == 1) then
							LoadNeckItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
						end
					else
						UpgradeListDBVar.char.SecondarySpecList.Neck.Row[UpgradeListDBVar.char.SecondarySpecList.Neck.Count] = { UpgradeListDBVar.char.SecondarySpecList.Neck.Count, itemLevel, UPGRADELIST_SELECTEDDIFFICULTY, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.SecondarySpecList.Neck.Count = UpgradeListDBVar.char.SecondarySpecList.Neck.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 2) and (ViewSecondarySpec:GetChecked() == 1) then
							LoadNeckItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
						end
					end
				elseif itemEquipLoc == "INVTYPE_SHOULDER" then --Shoulder Item
					if PrimarySpecRadioButton:GetChecked() then
						UpgradeListDBVar.char.PrimarySpecList.Shoulder.Row[UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count] = { UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count, itemLevel, UPGRADELIST_SELECTEDDIFFICULTY, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count = UpgradeListDBVar.char.PrimarySpecList.Shoulder.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 3) and (ViewPrimarySpec:GetChecked() == 1) then
							LoadShoulderItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
						end
					else
						UpgradeListDBVar.char.SecondarySpecList.Shoulder.Row[UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count] = { UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count, itemLevel, UPGRADELIST_SELECTEDDIFFICULTY, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count = UpgradeListDBVar.char.SecondarySpecList.Shoulder.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 3) and (ViewSecondarySpec:GetChecked() == 1) then
							LoadShoulderItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
						end
					end
				elseif itemEquipLoc == "INVTYPE_CLOAK" then --Back Item
					if PrimarySpecRadioButton:GetChecked() then
						UpgradeListDBVar.char.PrimarySpecList.Back.Row[UpgradeListDBVar.char.PrimarySpecList.Back.Count] = { UpgradeListDBVar.char.PrimarySpecList.Back.Count, itemLevel, UPGRADELIST_SELECTEDDIFFICULTY, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.PrimarySpecList.Back.Count = UpgradeListDBVar.char.PrimarySpecList.Back.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 4) and (ViewPrimarySpec:GetChecked() == 1) then
							LoadBackItems(ScrollingTable, ViewPrimarySpec, ViewPrimarySpec);
						end
					else
						UpgradeListDBVar.char.SecondarySpecList.Back.Row[UpgradeListDBVar.char.SecondarySpecList.Back.Count] = { UpgradeListDBVar.char.SecondarySpecList.Back.Count, itemLevel, UPGRADELIST_SELECTEDDIFFICULTY, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.SecondarySpecList.Back.Count = UpgradeListDBVar.char.SecondarySpecList.Back.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 4) and (ViewSecondarySpec:GetChecked() == 1) then
							LoadBackItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
						end
					end
				elseif itemEquipLoc == "INVTYPE_CHEST" or itemEquipLoc == "INVTYPE_ROBE" then --Chest Item
					if PrimarySpecRadioButton:GetChecked() then
						UpgradeListDBVar.char.PrimarySpecList.Chest.Row[UpgradeListDBVar.char.PrimarySpecList.Chest.Count] = { UpgradeListDBVar.char.PrimarySpecList.Chest.Count, itemLevel, UPGRADELIST_SELECTEDDIFFICULTY, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.PrimarySpecList.Chest.Count = UpgradeListDBVar.char.PrimarySpecList.Chest.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 5) and (ViewPrimarySpec:GetChecked() == 1) then
							LoadChestItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
						end
					else
						UpgradeListDBVar.char.SecondarySpecList.Chest.Row[UpgradeListDBVar.char.SecondarySpecList.Chest.Count] = { UpgradeListDBVar.char.SecondarySpecList.Chest.Count, itemLevel, UPGRADELIST_SELECTEDDIFFICULTY, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.SecondarySpecList.Chest.Count = UpgradeListDBVar.char.SecondarySpecList.Chest.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 5) and (ViewSecondarySpec:GetChecked() == 1) then
							LoadChestItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
						end
					end
				elseif itemEquipLoc == "INVTYPE_WRIST" then --Wrist Item
					if PrimarySpecRadioButton:GetChecked() then
						UpgradeListDBVar.char.PrimarySpecList.Wrist.Row[UpgradeListDBVar.char.PrimarySpecList.Wrist.Count] = { UpgradeListDBVar.char.PrimarySpecList.Wrist.Count, itemLevel, UPGRADELIST_SELECTEDDIFFICULTY, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.PrimarySpecList.Wrist.Count = UpgradeListDBVar.char.PrimarySpecList.Wrist.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 6) and (ViewPrimarySpec:GetChecked() == 1) then
							LoadWristItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
						end
					else
						UpgradeListDBVar.char.SecondarySpecList.Wrist.Row[UpgradeListDBVar.char.SecondarySpecList.Wrist.Count] = { UpgradeListDBVar.char.SecondarySpecList.Wrist.Count, itemLevel, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.SecondarySpecList.Wrist.Count = UpgradeListDBVar.char.SecondarySpecList.Wrist.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 6) and (ViewSecondarySpec:GetChecked() == 1) then
							LoadWristItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
						end
					end
				elseif itemEquipLoc == "INVTYPE_HAND" then --Hand Item
					if PrimarySpecRadioButton:GetChecked() then
						UpgradeListDBVar.char.PrimarySpecList.Hand.Row[UpgradeListDBVar.char.PrimarySpecList.Hand.Count] = { UpgradeListDBVar.char.PrimarySpecList.Hand.Count, itemLevel, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.PrimarySpecList.Hand.Count = UpgradeListDBVar.char.PrimarySpecList.Hand.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 7) and (ViewPrimarySpec:GetChecked() == 1) then
							LoadHandItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
						end
					else
						UpgradeListDBVar.char.SecondarySpecList.Hand.Row[UpgradeListDBVar.char.SecondarySpecList.Hand.Count] = { UpgradeListDBVar.char.SecondarySpecList.Hand.Count, itemLevel, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.SecondarySpecList.Hand.Count = UpgradeListDBVar.char.SecondarySpecList.Hand.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 7) and (ViewSecondarySpec:GetChecked() == 1) then
							LoadHandItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
						end
					end
				elseif itemEquipLoc == "INVTYPE_WAIST" then --Waist Item
					if PrimarySpecRadioButton:GetChecked() then
						UpgradeListDBVar.char.PrimarySpecList.Waist.Row[UpgradeListDBVar.char.PrimarySpecList.Waist.Count] = { UpgradeListDBVar.char.PrimarySpecList.Waist.Count, itemLevel, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.PrimarySpecList.Waist.Count = UpgradeListDBVar.char.PrimarySpecList.Waist.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 8) and (ViewPrimarySpec:GetChecked() == 1) then
							LoadWaistItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
						end
					else
						UpgradeListDBVar.char.SecondarySpecList.Waist.Row[UpgradeListDBVar.char.SecondarySpecList.Waist.Count] = { UpgradeListDBVar.char.SecondarySpecList.Waist.Count, itemLevel, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.SecondarySpecList.Waist.Count = UpgradeListDBVar.char.SecondarySpecList.Waist.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 8) and (ViewSecondarySpec:GetChecked() == 1) then
							LoadWaistItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
						end
					end
				elseif itemEquipLoc == "INVTYPE_LEGS" then --Leg Item
					if PrimarySpecRadioButton:GetChecked() then
						UpgradeListDBVar.char.PrimarySpecList.Leg.Row[UpgradeListDBVar.char.PrimarySpecList.Leg.Count] = { UpgradeListDBVar.char.PrimarySpecList.Leg.Count, itemLevel, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.PrimarySpecList.Leg.Count = UpgradeListDBVar.char.PrimarySpecList.Leg.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 9) and (ViewPrimarySpec:GetChecked() == 1) then
							LoadLegItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
						end
					else
						UpgradeListDBVar.char.SecondarySpecList.Leg.Row[UpgradeListDBVar.char.SecondarySpecList.Leg.Count] = { UpgradeListDBVar.char.SecondarySpecList.Leg.Count, itemLevel, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.SecondarySpecList.Leg.Count = UpgradeListDBVar.char.SecondarySpecList.Leg.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 9) and (ViewSecondarySpec:GetChecked() == 1) then
							LoadLegItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
						end
					end
				elseif itemEquipLoc == "INVTYPE_FEET" then --Foot Item
					if PrimarySpecRadioButton:GetChecked() then
						UpgradeListDBVar.char.PrimarySpecList.Foot.Row[UpgradeListDBVar.char.PrimarySpecList.Foot.Count] = { UpgradeListDBVar.char.PrimarySpecList.Foot.Count, itemLevel, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.PrimarySpecList.Foot.Count = UpgradeListDBVar.char.PrimarySpecList.Foot.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 10) and (ViewPrimarySpec:GetChecked() == 1) then
							LoadFootItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
						end
					else
						UpgradeListDBVar.char.SecondarySpecList.Foot.Row[UpgradeListDBVar.char.SecondarySpecList.Foot.Count] = { UpgradeListDBVar.char.SecondarySpecList.Foot.Count, itemLevel, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.SecondarySpecList.Foot.Count = UpgradeListDBVar.char.SecondarySpecList.Foot.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 10) and (ViewSecondarySpec:GetChecked() == 1) then
							LoadFootItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
						end
					end
				elseif itemEquipLoc == "INVTYPE_FINGER" then --Rings
					if PrimarySpecRadioButton:GetChecked() then
						UpgradeListDBVar.char.PrimarySpecList.Ring.Row[UpgradeListDBVar.char.PrimarySpecList.Ring.Count] = { UpgradeListDBVar.char.PrimarySpecList.Ring.Count, itemLevel, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.PrimarySpecList.Ring.Count = UpgradeListDBVar.char.PrimarySpecList.Ring.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 11) and (ViewPrimarySpec:GetChecked() == 1) then
							LoadRingItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
						end
					else
						UpgradeListDBVar.char.SecondarySpecList.Ring.Row[UpgradeListDBVar.char.SecondarySpecList.Ring.Count] = { UpgradeListDBVar.char.SecondarySpecList.Ring.Count, itemLevel, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.SecondarySpecList.Ring.Count = UpgradeListDBVar.char.SecondarySpecList.Ring.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 11) and (ViewSecondarySpec:GetChecked() == 1) then
							LoadRingItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
						end
					end
				elseif itemEquipLoc == "INVTYPE_TRINKET" then --Trinkets
					if PrimarySpecRadioButton:GetChecked() then
						UpgradeListDBVar.char.PrimarySpecList.Trinket.Row[UpgradeListDBVar.char.PrimarySpecList.Trinket.Count] = { UpgradeListDBVar.char.PrimarySpecList.Trinket.Count, itemLevel, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.PrimarySpecList.Trinket.Count = UpgradeListDBVar.char.PrimarySpecList.Trinket.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 12) and (ViewPrimarySpec:GetChecked() == 1) then
							LoadTrinketItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
						end
					else
						UpgradeListDBVar.char.SecondarySpecList.Trinket.Row[UpgradeListDBVar.char.SecondarySpecList.Trinket.Count] = { UpgradeListDBVar.char.SecondarySpecList.Trinket.Count, itemLevel, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.SecondarySpecList.Trinket.Count = UpgradeListDBVar.char.SecondarySpecList.Trinket.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 12) and (ViewSecondarySpec:GetChecked() == 1) then
							LoadTrinketItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
						end
					end
				elseif itemEquipLoc == "INVTYPE_WEAPONMAINHAND" or itemEquipLoc == "INVTYPE_2HWEAPON" then --Main Hand Item
					if PrimarySpecRadioButton:GetChecked() then
						UpgradeListDBVar.char.PrimarySpecList.Main.Row[UpgradeListDBVar.char.PrimarySpecList.Main.Count] = { UpgradeListDBVar.char.PrimarySpecList.Main.Count, itemLevel, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.PrimarySpecList.Main.Count = UpgradeListDBVar.char.PrimarySpecList.Main.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 13) and (ViewPrimarySpec:GetChecked() == 1) then
							LoadMainItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
						end
					else
						UpgradeListDBVar.char.SecondarySpecList.Main.Row[UpgradeListDBVar.char.SecondarySpecList.Main.Count] = { UpgradeListDBVar.char.SecondarySpecList.Main.Count, itemLevel, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.SecondarySpecList.Main.Count = UpgradeListDBVar.char.SecondarySpecList.Main.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 13) and (ViewSecondarySpec:GetChecked() == 1) then
							LoadMainItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
						end
					end
				elseif itemEquipLoc == "INVTYPE_WEAPONOFFHAND" or itemEquipLoc == "INVTYPE_SHIELD" or itemEquipLoc == "INVTYPE_HOLDABLE" then --Off Hand Item
					if PrimarySpecRadioButton:GetChecked() then
						UpgradeListDBVar.char.PrimarySpecList.Off.Row[UpgradeListDBVar.char.PrimarySpecList.Off.Count] = { UpgradeListDBVar.char.PrimarySpecList.Off.Count, itemLevel, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.PrimarySpecList.Off.Count = UpgradeListDBVar.char.PrimarySpecList.Off.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 14) and (ViewPrimarySpec:GetChecked() == 1) then
							LoadOffItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
						end
					else
						UpgradeListDBVar.char.SecondarySpecList.Off.Row[UpgradeListDBVar.char.SecondarySpecList.Off.Count] = { UpgradeListDBVar.char.SecondarySpecList.Off.Count, itemLevel, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.SecondarySpecList.Off.Count = UpgradeListDBVar.char.SecondarySpecList.Off.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 14) and (ViewSecondarySpec:GetChecked() == 1) then
							LoadOffItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
						end
					end
				elseif itemEquipLoc == "INVTYPE_RANGED" or itemEquipLoc == "INVTYPE_THROWN" or itemEquipLoc == "INVTYPE_RANGEDRIGHT" or itemEquipLoc == "INVTYPE_RELIC" then --Ranged Slot Item
					if PrimarySpecRadioButton:GetChecked() then
						UpgradeListDBVar.char.PrimarySpecList.Ranged.Row[UpgradeListDBVar.char.PrimarySpecList.Ranged.Count] = { UpgradeListDBVar.char.PrimarySpecList.Ranged.Count, itemLevel, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.PrimarySpecList.Ranged.Count = UpgradeListDBVar.char.PrimarySpecList.Ranged.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 15) and (ViewPrimarySpec:GetChecked() == 1) then
							LoadRangedItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
						end
					else
						UpgradeListDBVar.char.SecondarySpecList.Ranged.Row[UpgradeListDBVar.char.SecondarySpecList.Ranged.Count] = { UpgradeListDBVar.char.SecondarySpecList.Ranged.Count, itemLevel, itemLink, "Instance", "Boss", "Note" };
						UpgradeListDBVar.char.SecondarySpecList.Ranged.Count = UpgradeListDBVar.char.SecondarySpecList.Ranged.Count + 1;
						if (PanelTemplates_GetSelectedTab(MF) == 15) and (ViewSecondarySpec:GetChecked() == 1) then
							LoadRangedItems(ScrollingTable, ViewPrimarySpec, ViewSecondarySpec);
						end
					end
				elseif itemEquipLoc == "INVTYPE_WEAPON" then --Main Hand OR Off Hand Item
					--FIGURE OUT HOW TO MAKE A POPUP WINDOW ASKING THE USER IF THEY WANT TO PUT THE ITEM IN THEIR MAIN HAND OR OFF HAND LIST.
				else
					statusbarfont:SetTextColor(1, 0, 0);
					statusbarfont:SetText("ERROR: Unable to determine " .. itemLink .. "'s equip location.");
				end				
			end
		else
			statusbarfont:SetTextColor(1, 0, 0);
			statusbarfont:SetText("ERROR: Unable to determine your class.");
		end
	end
end